<?php

namespace Drupal\commerce_order_locking;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;
use Symfony\Component\DependencyInjection\Reference;

/**
 * Registers event subscribers for installed Commerce modules.
 */
class CommerceOrderLockingServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function register(ContainerBuilder $container) {
    // We cannot use the module handler as the container is not yet compiled.
    // @see \Drupal\Core\DrupalKernel::compileContainer()
    $modules = $container->getParameter('container.modules');

    if (isset($modules['commerce_log'])) {
      $container->register('commerce_order_locking.order_subscriber.log_aware', 'Drupal\commerce_order_locking\EventSubscriber\OrderSubscriberLogAware')
        ->addTag('event_subscriber')
        ->addArgument(new Reference('entity_type.manager'));
    }
  }
}
